import os
from pathlib import Path

class HaConstant:
    # 프로젝트 루트 디렉토리 설정
    ROOT_DIR = Path(__file__).parent  # digiloglab_aibe_core 폴더
    
    REPO_DIR =  Path("D:\\black_stt_repo") # 사무실 컴퓨터에만 적용됨.
    # 기본 디렉토리들
    DATA_DIR = os.path.join(ROOT_DIR, "data")
    MODELS_DIR = os.path.join(ROOT_DIR, "models")
    
    # 구글 드라이브 관련 설정
    google_drive_credential_path = os.path.join(DATA_DIR, "credentials", "google_drive_credential.json")
    google_drive_folder_id = "1jqhwTvJPWqHvgw7MYyHly7TY4iIVWlUo"
    
    # 비디오 관련 디렉토리
    video_dir = os.path.join(REPO_DIR, "video", "youtube")
    audio_dir = os.path.join(video_dir, "audios")
    text_dir = os.path.join(video_dir, "texts")
    embed_dir = os.path.join(video_dir, "embeddings")
    chunks_dir = os.path.join(video_dir, "chunks")
    
    # 캐시 관련 디렉토리
    cache_dir = os.path.join(video_dir, "cache")
    cache_embeddings_dir = os.path.join(cache_dir, "embeddings")
    cache_files_dir = os.path.join(cache_dir, "files")
    pdf_dir = os.path.join(video_dir, "pdfs")
    
    @classmethod
    def create_directories(cls):
        """필요한 모든 디렉토리를 생성합니다."""
        directories = [
            cls.REPO_DIR,
            cls.DATA_DIR,
            cls.MODELS_DIR,
            cls.video_dir,
            cls.audio_dir,
            cls.text_dir,
            cls.embed_dir,
            cls.chunks_dir,
            cls.cache_dir,
            cls.cache_embeddings_dir,
            cls.cache_files_dir,
            cls.pdf_dir,
        ]
        
        for directory in directories:
            os.makedirs(directory, exist_ok=True)