import requests
import os
from dotenv import load_dotenv
from requests_toolbelt.multipart.encoder import MultipartEncoder
import base64
import json
import ngrok
import asyncio

load_dotenv()



class DagloTask():
    # https://developers.daglo.ai/guide/Quick-Speech-Voice-To-Text.html
    # https://apis.daglo.ai/docs#/

    def __init__(self):
        self.api_key = os.getenv("DAGLO_API_KEY")
        self.headers = {
            "Content-Type": "application/json",
            "Authorization": f"Bearer {self.api_key}",
        }
    


    def send_daglo_unit(self, audio_file_path):
        url = "https://apis.daglo.ai/stt/v1/async/transcripts"
        data = {
            "audio": {
                "source": {
                    "url": audio_file_path
                }
            }   
        }

        json_data = json.dumps(data)

        response = requests.post(url, headers=self.headers, data=json_data) #, allow_redirects=False)
        return response.json()
    
    def get_daglo_unit(self, rid):
        url = f"https://apis.daglo.ai/stt/v1/async/transcripts/{rid}"
        response = requests.get(url, headers=self.headers)
        return response.json()
